; 
      PRINTDLGEX  equ  <PRINTDLGB>
      PRINTDLGB STRUCT
          lStructSize          DWORD ?
          hwndOwner            DWORD ?
          hDevMode             DWORD ?
          hDevNames            DWORD ?
          hDC                  DWORD ?
          Flags                DWORD ?
          Flags2               DWORD ?
          ExclusionFlags       DWORD ?
          nPageRanges          DWORD ?
          nMaxPageRanges       DWORD ?
          lpPageRanges         DWORD ?
          nMinPage             DWORD ?
          nMaxPage             DWORD ?
          nCopies              DWORD ?
          hInstance            DWORD ?
          lpPrintTemplateName  DWORD ?
          lpCallback           DWORD ?
          nPropertyPages       DWORD ?
          lphPropertyPages     DWORD ?
          nStartPage           DWORD ?
          dwResultAction       DWORD ?
      PRINTDLGB ENDS
      PRINTPAGERANGE STRUCT
          nFromPage DWORD ?
          nToPage   DWORD ?
      PRINTPAGERANGE ENDS
; 
DisplayPrintPropertySheet proc hWin :DWORD
;
; This coding only displays the Print Dlg box and shows the General Tab.
; The Layout Tab and the Paper/Quality Tabs do not show as demonstrated in the SDK example.
;
    LOCAL hResult      :DWORD
    LOCAL pPDX         :DWORD
    LOCAL pPageRanges  :DWORD
    
    mov eax, NULL
    mov pPDX, eax
    mov pPageRanges, eax
; -----------------------------------
    mov pPDX, rv(GlobalAlloc, GPTR, sizeof( PRINTDLGEX ))
              ; If the function succeeds, the return value is a handle to the newly allocated memory object.
              ; If the function fails, the return value is NULL.
              .if pPDX == NULL
                  ; Display Error Message - Memory Allocate Error
                  jmp quick_exit
              .endif
; -----------------------------------
    mov pPageRanges, rv(GlobalAlloc, GPTR, 10 * sizeof( PRINTPAGERANGE ))  ; Allow for max of 10 child tabs
    .if pPageRanges == NULL
        ; Display Error Message - Memory Allocate Error
        jmp quick_exit
    .endif
; -----------------------------------
    push esi
    ;  Initialize the PRINTDLGEX structure.
    mov esi, pPDX
    mov (PRINTDLGEX PTR [esi]).lStructSize,         sizeof(PRINTDLGEX)
    m2m (PRINTDLGEX PTR [esi]).hwndOwner,           hWin                ; need to use m2m here
    mov (PRINTDLGEX PTR [esi]).hDevMode,            NULL
    mov (PRINTDLGEX PTR [esi]).hDevNames,           NULL
    mov (PRINTDLGEX PTR [esi]).hDC,                 NULL
    mov (PRINTDLGEX PTR [esi]).Flags,               PD_RETURNDC or PD_COLLATE
    mov (PRINTDLGEX PTR [esi]).Flags2,              0
    mov (PRINTDLGEX PTR [esi]).ExclusionFlags,      0
    mov (PRINTDLGEX PTR [esi]).nPageRanges,         0
    mov (PRINTDLGEX PTR [esi]).nMaxPageRanges,      10
    m2m (PRINTDLGEX PTR [esi]).lpPageRanges,        pPageRanges         ; need to use m2m here
    mov (PRINTDLGEX PTR [esi]).nMinPage,            1
    mov (PRINTDLGEX PTR [esi]).nMaxPage,            1000
    mov (PRINTDLGEX PTR [esi]).nCopies,             1
    mov (PRINTDLGEX PTR [esi]).hInstance,           0
    mov (PRINTDLGEX PTR [esi]).lpPrintTemplateName, NULL
    mov (PRINTDLGEX PTR [esi]).lpCallback,          NULL
    mov (PRINTDLGEX PTR [esi]).nPropertyPages,      0
    mov (PRINTDLGEX PTR [esi]).lphPropertyPages,    NULL
    mov (PRINTDLGEX PTR [esi]).nStartPage,          START_PAGE_GENERAL  ; windows.inc defined as ffffffffh s/b 0ffffffffh
    mov (PRINTDLGEX PTR [esi]).dwResultAction,      0
    pop esi
    invoke PrintDlgEx, pPDX                         ; Displays the Dlg Box for user interaction
    mov hResult, eax                                ; Store returned value
    push esi                                        ; Save register
    mov esi, pPDX                                   ; Get pointer
    mov eax, (PRINTDLGEX PTR [esi]).dwResultAction  ; Get pointer.dwResultAction and put into eax
    pop esi                                         ; Restore register
    .if hResult == S_OK && eax == PD_RESULT_PRINT   ; Both conditions must be true before printing can begin
           ;
           ;      Call Print rendering routines here
           ;           Insert Abort Dlg here within rending routines
           ;
    .endif
quick_exit:
    push esi
    mov esi, pPDX
    mov eax, (PRINTDLGEX PTR [esi]).hDC
    .if eax != NULL
        invoke DeleteDC, (PRINTDLGEX PTR [esi]).hDC
    .endif
    mov esi, pPDX
    mov eax, (PRINTDLGEX PTR [esi]).hDevMode
    .if eax != NULL
        invoke GlobalFree, (PRINTDLGEX PTR [esi]).hDevMode
    .endif
    mov esi, pPDX
    mov eax, (PRINTDLGEX PTR [esi]).hDevNames
    .if eax != NULL
        invoke GlobalFree, (PRINTDLGEX PTR [esi]).hDevNames
    .endif
    pop esi
    .if pPDX != NULL
        invoke GlobalFree, pPDX
    .endif
    .if pPageRanges != NULL
        invoke GlobalFree, pPageRanges
    .endif
    ret
DisplayPrintPropertySheet endp
; 
;
;   The following was taken from Platform SDK for Windows XP SP2 file
;
; Using the Print Property Sheet
; Tabbed child windows (General, Layout, Paper/Quality) with the Print Dlg
;
; This topic describes sample code that displays a Print property sheet so
; a user can select options for printing a document.
;
; The sample code first allocates and initializes a PRINTDLGEX structure,
; then calls the PrintDlgEx function to display the property sheet.
;
; The sample code sets the PD_RETURNDC flag in the Flags member of the PRINTDLG structure.
; This causes the PrintDlgEx function to return a device context handle for the selected printer in the hDC member.
; You can use the handle in functions such as that render output sent to the printer.
;
; On input, the sample code sets the hDevMode and hDevNames members to NULL.
; If the function returns S_OK, these members return handles to and DEVNAMES structures containing the user's input and
; information about the printer. You can use this information to prepare the output to be sent to the selected printer.
;
; After the printing operation has been completed, the sample code frees the DEVMODE and DEVNAMES buffers and
; calls the function to delete the device context.
; =========================
; HRESULT DisplayPrintPropertySheet(HWND hWnd  // Window that owns the property sheet)
; {
; HRESULT hResult;
; LPPRINTDLGEX pPDX = NULL;
; LPPRINTPAGERANGE pPageRanges = NULL;
;
; // Allocate the PRINTDLGEX structure.
; pPDX = (LPPRINTDLGEX)GlobalAlloc(GPTR, sizeof(PRINTDLGEX));
; if (!pPDX) return E_OUTOFMEMORY;
;
; // Allocate an array of PRINTPAGERANGE structures.
; pPageRanges = (LPPRINTPAGERANGE) GlobalAlloc(GPTR, 10 * sizeof(PRINTPAGERANGE));
; if (!pPageRanges) return E_OUTOFMEMORY;
;
; //  Initialize the PRINTDLGEX structure.
; pPDX->lStructSize         = sizeof(PRINTDLGEX);
; pPDX->hwndOwner           = hWnd;
; pPDX->hDevMode            = NULL;
; pPDX->hDevNames           = NULL;
; pPDX->hDC                 = NULL;
; pPDX->Flags               = PD_RETURNDC | PD_COLLATE;
; pPDX->Flags2              = 0;
; pPDX->ExclusionFlags      = 0;
; pPDX->nPageRanges         = 0;
; pPDX->nMaxPageRanges      = 10;
; pPDX->lpPageRanges        = pPageRanges;
; pPDX->nMinPage            = 1;
; pPDX->nMaxPage            = 1000;
; pPDX->nCopies             = 1;
; pPDX->hInstance           = 0;
; pPDX->lpPrintTemplateName = NULL;
; pPDX->lpCallback          = NULL;
; pPDX->nPropertyPages      = 0;
; pPDX->lphPropertyPages    = NULL;
; pPDX->nStartPage          = START_PAGE_GENERAL;
; pPDX->dwResultAction      = 0;
;
; //  Invoke the Print property sheet.
; hResult = PrintDlgEx(pPDX);
;
; if ((hResult == S_OK) && pPDX->dwResultAction == PD_RESULT_PRINT)
; {
;     // User clicked the Print button, so use the DC and other information returned in the PRINTDLGEX structure to print the document
; }
; if (pPDX->hDC != NULL)           DeleteDC(pPDX->hDC);
; if (pPDX->hDevMode != NULL)      GlobalFree(pPDX->hDevMode);
; if (pPDX->hDevNames != NULL)     GlobalFree(pPDX->hDevNames);
; return hResult;
; }
;-----------------------------------------------------------------------
